package minmax;

public class MinMaxMemory implements IMinMaxMemory {
	private String shortest = null;
	private String longest = null;
	
	public void remember(String s) throws IllegalArgumentException {
	    if ( s == null )
	    	throw new IllegalArgumentException("null string passed to remember");
	    if ( shortest == null || s.length() <= shortest.length() )
	    	shortest = s;
	    if ( longest == null || s.length() >= longest.length() )
	    	longest = s;
	}
	public int getMinLength() {
	    return shortest.length();
	}
	public int getMaxLength() {
	    return longest.length();
	}
}
