package comparatortest;
import java.util.Comparator;
import java.util.TreeSet;

import buffer.Buffer;
import buffer.SortedBuffer;
public class TestComparators {
    public static void main(String[] arg) {
// //      detta kompilerar, men ...
//         Buffer<C> buf1 = new SortedBuffer<C>(10);
// //      hr upptcks att C inte r jmfrbar
//         buf1.insert(new C(2));
//         buf1.insert(new C(1));

        // Detta fungerar, C r ej jmfrbar, men komparator medskickad
        Buffer<C> buf2 = new SortedBuffer<C>(new CComparator(),10);
        buf2.insert(new C(2));
        buf2.insert(new C(1));

        // Detta fungerar, C r ej jmfrbar, men komparator medskickad
        Buffer<CSub> buf3 = new SortedBuffer<CSub>(new CComparator(),10);
        buf3.insert(new CSub(2));
        buf3.insert(new CSub(1));
        
        // Detta fungerar, compareTo i D anvnds av komparatorn som returneras av 
        // Comparator.naturalOrder() i SortedBuffer:s konstruktor
        Buffer<D> buf4 = new SortedBuffer<D>(10);
        buf4.insert(new D(2));
        buf4.insert(new D(1));
 
        // Detta fungerar, C r ej jmfrbar, men komparator medskickad
        TreeSet<C> t1 = new TreeSet<>(new CComparator());
        t1.add(new C(2)); 
        t1.add(new C(1)); 
        
        TreeSet<C> t2 = new TreeSet<>();
        t2.add(new C(2)); // Hr upptcks att C inte r jmfrbar
        t2.add(new C(1));
    }    
}
