package buffer;
public interface Buffer<T> {
    boolean isEmpty();
    boolean isFull();
    int getSize();
    int getCapacity();
    T get(int i) throws IndexOutOfBoundsException;
    void insert(T x) throws IllegalStateException;
    void remove(int i) throws IndexOutOfBoundsException;
    String toString();
}
